[ VIGRA Homepage | Function Index | Class Index | Namespaces | File List | Main Page ]

| BlockwiseOptions Class Reference |

`#include <vigra/multi_blockwise.hxx>`

Inheritance diagram for BlockwiseOptions:

## Public Member Functions

BlockwiseOptions & | blockShape (const Shape &blockShape)
template<class T , int N>
BlockwiseOptions & | blockShape (const TinyVector< T, N > &blockShape)
BlockwiseOptions & | blockShape (MultiArrayIndex blockShape)
Shape const & | getBlockShape () const
template<int N>
TinyVector< MultiArrayIndex, N > | getBlockShapeN () const
Public Member Functions inherited from ParallelOptions
int | getActualNumThreads () const
| Get desired number of threads. More...
int | getNumThreads () const
| Get desired number of threads. More...
ParallelOptions & | numThreads (const int n)
| Set the number of threads or one of the constants `Auto`, `Nice` and `NoThreads`. More...

## Additional Inherited Members

Public Types inherited from ParallelOptions
enum | { Auto = -1, Nice = -2, NoThreads = 0 }

## Detailed Description

Option base class for blockwise algorithms.

Attaches blockshape to ParallelOptions.

## Member Function Documentation

## ◆ getBlockShape()

Shape const& getBlockShape | ( |  | ) | const

Retrieve block shape as a std::vector.

If the returned vector is empty, a default block shape should be used. If the returned vector has length 1, square blocks of size `getBlockShape()[0]` should be used.

## ◆ getBlockShapeN()

TinyVector<MultiArrayIndex, N> getBlockShapeN | ( |  | ) | const

Retrieve block shape as a fixed-size vector.

Default shape specifications are appropriately expanded. An exception is raised if the stored shape's length is incompatible with dimension `N`.

## ◆ blockShape() [1/3]

BlockwiseOptions& blockShape | ( | const Shape & | blockShape | ) |

Specify block shape as a std::vector of appropriate length. If `blockShape.size() == 0`, the default shape is used. If `blockShape.size() == 1`, square blocks of size `blockShape[0]` are used.

Default: Use square blocks with side length `VIGRA_DEFAULT_BLOCK_SHAPE`.

## ◆ blockShape() [2/3]

BlockwiseOptions& blockShape | ( | const TinyVector< T, N > & | blockShape | ) |

Specify block shape by a fixed-size shape object.

## ◆ blockShape() [3/3]

BlockwiseOptions& blockShape | ( | MultiArrayIndex | blockShape | ) |

Specify square block shape by its side length.

The documentation for this class was generated from the following file:

- vigra/multi_blockwise.hxx

© Ullrich Köthe (ullrich.koethe@iwr.uni-heidelberg.de) Heidelberg Collaboratory for Image Processing, University of Heidelberg, Germany | html generated using doxygen and Python vigra 1.11.0